#!/bin/bash
# maintainer         : Frederic Boulet <bipbip> bipbiponlinux~AT~gmail.com
# build from         : Fred. Galusik <fredg> (fred~AT~zenwalk.fr)
# packager           : Guth <guth-AT-ploposor.com>
# source location    : http://www.tomatarium.pwp.blueyonder.co.uk/cryptkeeper/cryptkeeper-0.9.5.tar.gz

softname='cryptkeeper'
softversion='0.9.5'
packageversion='64.1'

arch='i486'
cpu='i686'

# log ;)
(

# parameters needed for the build process
buildir=$(pwd)
srcpkg="$buildir/$softname-$softversion.tar.gz"
src="$buildir/$softname-$softversion"
package="$softname-$softversion-$arch-$packageversion"
dest="$buildir/$package"

# prepare the build result directory
dest="$buildir/$package"
rm -rf $dest
mkdir -p $dest
mkdir -p $dest/install
mkdir -p $dest/usr/doc/$softname-$softversion
mkdir -p $dest/usr/share/icons/hicolor/48x48/apps/
mkdir -p $dest/usr/src/$softname-$softversion

# Slack-desc
cat <<EOF > $dest/install/slack-desc
           |-----handy-ruler------------------------------------------------------|
cryptkeeper: cryptkeeper (encfs system tray applet)
cryptkeeper:
cryptkeeper: Cryptkeeper is a Linux system tray applet that manages EncFS
cryptkeeper: encrypted folders.
cryptkeeper: 
cryptkeeper: 
cryptkeeper:
cryptkeeper: 
cryptkeeper:
cryptkeeper:
cryptkeeper:

EOF

# extract the source code
cd $buildir
tar xvf $srcpkg
cd $src

patch -p1 < ../fix_cryptkeeper.desktop.patch
patch -p1 < ../gcc-4.4-fix.patch

# build

    export CFLAGS="-O2 -march=$arch -mtune=$cpu"
    export CXXFLAGS="-O2 -march=$arch -mtune=$cpu"

    ./configure \
      --prefix=/usr \
      --mandir=/usr \
      --program-prefix="" \
      --program-suffix="" \
      --build=$arch-slackware-linux

    make
    make install DESTDIR=$dest

# add 'default' files
    cp -a \
      ABOUT-NLS COPYING ChangeLog TODO \
      $dest/usr/doc/$softname-$softversion

# Strip
( cd $dest
  find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
  find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
)

# Make the package freedesktop compliant
cp $buildir/$softname-$softversion/$softname.png $dest/usr/share/icons/hicolor/48x48/apps/
rm -rf $dest/usr/share/pixmaps

# ZenBuild
cp $buildir/build-$softname.sh $buildir/$softname-${softversion}_symlink.patch $dest/usr/src/$softname-$softversion

# set target permissions
chown -R root:root $dest

cd $dest
find . -perm 664 -exec chmod 644 {} \;
find . -perm 600 -exec chmod 644 {} \;
find . -perm 444 -exec chmod 644 {} \;
find . -perm 400 -exec chmod 644 {} \;
find . -perm 440 -exec chmod 644 {} \;
find . -perm 777 -exec chmod 755 {} \;
find . -perm 775 -exec chmod 755 {} \;
find . -perm 511 -exec chmod 755 {} \;
find . -perm 711 -exec chmod 755 {} \;
find . -perm 555 -exec chmod 755 {} \;

# real packaging work
cd $dest
/sbin/makepkg -l y -c n $dest.txz

# md5sum signature
cd $buildir
md5sum $package.txz > $package.md5
echo "http://www.tomatarium.pwp.blueyonder.co.uk/cryptkeeper/cryptkeeper-0.9.5.tar.gz" > $package.src
echo "http://zenwalk.pinguix.com/user-accounts/bip/EXTRA/xap/cryptkeeper/build-cryptkeeper.sh" >> $package.src
echo "http://zenwalk.pinguix.com/user-accounts/bip/EXTRA/xap/cryptkeeper/fix_cryptkeeper.desktop.patch" >> $package.src
echo "http://zenwalk.pinguix.com/user-accounts/bip/EXTRA/xap/cryptkeeper/gcc-4.4-fix.patch" >> $package.src
echo -n "encfs" > $package.dep

# log ;)
) 2>&1 | tee "$softname-$softversion-build.log"
